#include <Bounce.h>

Bounce btn_Up     = Bounce( 0, 10);
Bounce btn_Down   = Bounce( 1, 10);
Bounce btn_Left   = Bounce( 2, 10);
Bounce btn_Right  = Bounce( 3, 10);


Bounce btn_A      = Bounce( 4, 10);
Bounce btn_B      = Bounce( 5, 10);
Bounce btn_X      = Bounce( 6, 10);
Bounce btn_Y      = Bounce( 7, 10);


Bounce btn_L1     = Bounce( 8, 10);
Bounce btn_L2     = Bounce( 9, 10);
Bounce btn_R1     = Bounce(10, 10);
Bounce btn_R2     = Bounce(11, 10);


Bounce btn_Start  = Bounce(20, 10);
Bounce btn_Select = Bounce(21, 10);


int    an_L_x     = A0;
int    an_L_y     = A1;
Bounce an_L_btn   = Bounce(16, 10);


int    an_R_x     = A3;
int    an_R_y     = A4;
Bounce an_R_btn   = Bounce(19, 10);



void setup() {
  pinMode( 0, INPUT_PULLUP);  //btn_Up   
  pinMode( 1, INPUT_PULLUP);  //btn_Down 
  pinMode( 2, INPUT_PULLUP);  //btn_Left 
  pinMode( 3, INPUT_PULLUP);  //btn_Right
  
  pinMode( 4, INPUT_PULLUP);  //btn_A
  pinMode( 5, INPUT_PULLUP);  //btn_B
  pinMode( 6, INPUT_PULLUP);  //btn_X
  pinMode( 7, INPUT_PULLUP);  //btn_Y
  
  pinMode( 8, INPUT_PULLUP);  //btn_L1
  pinMode( 9, INPUT_PULLUP);  //btn_L2
  pinMode(10, INPUT_PULLUP);  //btn_R1
  pinMode(11, INPUT_PULLUP);  //btn_R2
  
  pinMode(20, INPUT_PULLUP);  //btn_Start 
  pinMode(21, INPUT_PULLUP);  //btn_Select
  
  
  pinMode(A0, INPUT);         //an_L_x  
  pinMode(A1, INPUT);         //an_L_y  
  pinMode(16, INPUT_PULLUP);  //an_L_btn
  
  pinMode(A3, INPUT);         //an_R_x  
  pinMode(A4, INPUT);         //an_R_y  
  pinMode(19, INPUT_PULLUP);  //an_R_btn
}



void loop() {

  btn_Up.update();
  btn_Down.update();
  btn_Left.update();
  btn_Right.update();

  btn_A.update();
  btn_B.update();
  btn_X.update();
  btn_Y.update();

  btn_L1.update();
  btn_L2.update();
  btn_R1.update();
  btn_R2.update();

  btn_Start.update();
  btn_Select.update();

  an_L_btn.update();
  an_R_btn.update();

  

  if( btn_Up.fallingEdge() )     { Joystick.button( 1, 1); }
  if( btn_Down.fallingEdge() )   { Joystick.button( 2, 1); }
  if( btn_Left.fallingEdge() )   { Joystick.button( 3, 1); }
  if( btn_Right.fallingEdge() )  { Joystick.button( 4, 1); }

  if( btn_A.fallingEdge() )      { Joystick.button( 5, 1); }
  if( btn_B.fallingEdge() )      { Joystick.button( 6, 1); }
  if( btn_X.fallingEdge() )      { Joystick.button( 7, 1); }
  if( btn_Y.fallingEdge() )      { Joystick.button( 8, 1); }

  if( btn_L1.fallingEdge() )     { Joystick.button( 9, 1); }
  if( btn_L2.fallingEdge() )     { Joystick.button(10, 1); }
  if( btn_R1.fallingEdge() )     { Joystick.button(11, 1); }
  if( btn_R2.fallingEdge() )     { Joystick.button(12, 1); }

  if( btn_Start.fallingEdge() )  { Joystick.button(13, 1); }
  if( btn_Select.fallingEdge() ) { Joystick.button(14, 1); }

  if( an_L_btn.fallingEdge() )   { Joystick.button(15, 1); }
  if( an_R_btn.fallingEdge() )   { Joystick.button(16, 1); }
  


  if( btn_Up.risingEdge() )      { Joystick.button( 1, 0); }
  if( btn_Down.risingEdge() )    { Joystick.button( 2, 0); }
  if( btn_Left.risingEdge() )    { Joystick.button( 3, 0); }
  if( btn_Right.risingEdge() )   { Joystick.button( 4, 0); }

  if( btn_A.risingEdge() )       { Joystick.button( 5, 0); }
  if( btn_B.risingEdge() )       { Joystick.button( 6, 0); }
  if( btn_X.risingEdge() )       { Joystick.button( 7, 0); }
  if( btn_Y.risingEdge() )       { Joystick.button( 8, 0); }

  if( btn_L1.risingEdge() )      { Joystick.button( 9, 0); }
  if( btn_L2.risingEdge() )      { Joystick.button(10, 0); }
  if( btn_R1.risingEdge() )      { Joystick.button(11, 0); }
  if( btn_R2.risingEdge() )      { Joystick.button(12, 0); }

  if( btn_Start.risingEdge() )   { Joystick.button(13, 0); }
  if( btn_Select.risingEdge() )  { Joystick.button(14, 0); }

  if( an_L_btn.risingEdge() )    { Joystick.button(15, 0); }
  if( an_R_btn.risingEdge() )    { Joystick.button(16, 0); }
  
  
  Joystick.X(       analogRead( an_L_x ) );
  Joystick.Y(       analogRead( an_L_y ) );


  Joystick.Z(       analogRead( an_R_x ) );
  Joystick.Zrotate( analogRead( an_R_y ) );
}

